* This file cleans up the Pew data
use "Pew\pew_gap_final_44_country_dataset_1_1sav.dta", clear /* This is the file distributed by Pew*/
gen wt=weight
gen sex=2-q73
la var sex "0=female; 1=male"
replace sex=-1 if sex==.
gen sex_missing=(sex==-1)
gen age=q74 if q74~=98 & q74~=99
replace age=-1 if age==.
gen age_missing=age==-1

gen str3 cty=""
replace cty="AGO" if country==1
replace cty="ARG" if country==2
replace cty="BGD" if country==3
replace cty="BOL" if country==4
replace cty="BRA" if country==5
replace cty="BGR" if country==6
replace cty="CAN" if country==7
replace cty="CHN" if country==8
replace cty="CIV" if country==9
replace cty="CZE" if country==10
replace cty="EGY" if country==11
replace cty="FRA" if country==12
replace cty="DEU" if country==13
replace cty="GHA" if country==14
replace cty="GTM" if country==15
replace cty="HND" if country==16
replace cty="IND" if country==17
replace cty="IDN" if country==18
replace cty="ITA" if country==19
replace cty="JPN" if country==20
replace cty="KEN" if country==21
replace cty="KOR" if country==22
replace cty="MLI" if country==23
replace cty="MEX" if country==24
replace cty="NGA" if country==26
replace cty="PAK" if country==27
replace cty="PER" if country==28
replace cty="PHL" if country==29
replace cty="POL" if country==30
replace cty="RUS" if country==31
replace cty="SEN" if country==32
replace cty="SVK" if country==33
replace cty="ZAF" if country==34
replace cty="TZA" if country==35
replace cty="TUR" if country==36
replace cty="UGA" if country==37
replace cty="GBR" if country==38
replace cty="UKR" if country==39
replace cty="USA" if country==40
replace cty="UZB" if country==41
replace cty="VEN" if country==42
replace cty="VNM" if country==43
replace cty="LBN" if country==44
replace cty="JOR" if country==45

gen year=2002
sort cty year
merge cty year using "Processed files\Complete_GDP"
drop if _merge==2
tab cty if gdp==.
gen lgdp=ln(gdp)

la var gdp "GDP per capita, PPP (2000 US $)"

gen sat=q2
replace sat=. if sat>10
gen today=3 if q1==2
replace today=1 if q1==3
replace today=2 if q1==1

for var q5*: replace X=. if X>=97
for X in num 1/10 96: gen prob_X=q5_1rec==X | q5_2rec==X | q5_3rec==X
for X in num 1/10 96: tab q5_1rec if q5_1rec==X \ summ prob_X \ reg prob_X lgdp, cluster(cty)

for X in any inc_lower inc_upper: gen X=.
replace inc_lower=1 if q88ang==1
replace inc_lower=500 if q88ang==2
replace inc_lower=1000 if q88ang==3
replace inc_lower=1500 if q88ang==4
replace inc_lower=2000 if q88ang==5
replace inc_lower=2500 if q88ang==6
replace inc_lower=3000 if q88ang==7
replace inc_lower=3500 if q88ang==8
replace inc_lower=4000 if q88ang==9
replace inc_lower=4500 if q88ang==10
replace inc_lower=5000 if q88ang==11
replace inc_lower=5500 if q88ang==12
replace inc_lower=6000 if q88ang==13
replace inc_lower=6500 if q88ang==14
replace inc_lower=7000 if q88ang==15
replace inc_lower=7500 if q88ang==16
replace inc_lower=8000 if q88ang==17
replace inc_lower=8500 if q88ang==18
replace inc_lower=9000 if q88ang==19
replace inc_lower=9500 if q88ang==20
replace inc_lower=10000 if q88ang==21
replace inc_lower=11000 if q88ang==22
replace inc_lower=11500 if q88ang==23
replace inc_lower=12000 if q88ang==24
replace inc_lower=13000 if q88ang==25
replace inc_lower=14000 if q88ang==26
replace inc_lower=14500 if q88ang==27
replace inc_lower=15000 if q88ang==28
replace inc_lower=16000 if q88ang==29
replace inc_lower=20000 if q88arg==1
replace inc_lower=8001 if q88arg==4
replace inc_lower=5001 if q88arg==5
replace inc_lower=3001 if q88arg==6
replace inc_lower=2001 if q88arg==7
replace inc_lower=1601 if q88arg==8
replace inc_lower=1301 if q88arg==9
replace inc_lower=1001 if q88arg==10
replace inc_lower=851 if q88arg==11
replace inc_lower=701 if q88arg==12
replace inc_lower=551 if q88arg==13
replace inc_lower=451 if q88arg==14
replace inc_lower=351 if q88arg==15
replace inc_lower=201 if q88arg==16
replace inc_lower=0 if q88arg==17
replace inc_lower=5000 if q88ban==1
replace inc_lower=10000 if q88ban==2
replace inc_lower=15000 if q88ban==3
replace inc_lower=20000 if q88ban==4
replace inc_lower=50000 if q88ban==5
replace inc_lower=100000 if q88ban==6
replace inc_lower=0 if q88bol==1
replace inc_lower=201 if q88bol==2
replace inc_lower=401 if q88bol==3
replace inc_lower=601 if q88bol==4
replace inc_lower=801 if q88bol==5
replace inc_lower=1001 if q88bol==6
replace inc_lower=1501 if q88bol==7
replace inc_lower=3001 if q88bol==8
replace inc_lower=5001 if q88bol==9
replace inc_lower=7501 if q88bol==10
replace inc_lower=10001 if q88bol==11
replace inc_lower=15001 if q88bol==12
replace inc_lower=20000 if q88bol==13
replace inc_lower=0 if q88braz==1
replace inc_lower=201 if q88braz==2
replace inc_lower=401 if q88braz==3
replace inc_lower=601 if q88braz==4
replace inc_lower=1001 if q88braz==5
replace inc_lower=1401 if q88braz==6
replace inc_lower=2001 if q88braz==7
replace inc_lower=3001 if q88braz==8
replace inc_lower=4001 if q88braz==9
replace inc_lower=6001 if q88braz==10
replace inc_lower=10001 if q88braz==11
replace inc_lower=15001 if q88braz==12
replace inc_lower=0 if q88bul==1
replace inc_lower=100 if q88bul==2
replace inc_lower=200 if q88bul==3
replace inc_lower=300 if q88bul==4
replace inc_lower=400 if q88bul==5
replace inc_lower=500 if q88bul==6
replace inc_lower=600 if q88bul==7
replace inc_lower=700 if q88bul==8
replace inc_lower=800 if q88bul==9
replace inc_lower=900 if q88bul==10
replace inc_lower=1000 if q88bul==11
replace inc_lower=0 if q88can==1
replace inc_lower=20000 if q88can==2
replace inc_lower=30000 if q88can==3
replace inc_lower=40000 if q88can==4
replace inc_lower=60000 if q88can==5
replace inc_lower=80000 if q88can==6
replace inc_lower=100000 if q88can==7
replace inc_lower=0 if q88chi==1
replace inc_lower=500 if q88chi==2
replace inc_lower=1000 if q88chi==3
replace inc_lower=1500 if q88chi==4
replace inc_lower=2000 if q88chi==5
replace inc_lower=2500 if q88chi==6
replace inc_lower=3000 if q88chi==7
replace inc_lower=4000 if q88chi==8
replace inc_lower=5000 if q88chi==9
replace inc_lower=6000 if q88chi==10
replace inc_lower=7000 if q88chi==11
replace inc_lower=8000 if q88chi==12
replace inc_lower=80000 if q88czh==1
replace inc_lower=50001 if q88czh==2
replace inc_lower=35001 if q88czh==3
replace inc_lower=25001 if q88czh==4
replace inc_lower=20001 if q88czh==5
replace inc_lower=17001 if q88czh==6
replace inc_lower=14001 if q88czh==7
replace inc_lower=12001 if q88czh==8
replace inc_lower=10001 if q88czh==9
replace inc_lower=9001 if q88czh==10
replace inc_lower=8001 if q88czh==11
replace inc_lower=7001 if q88czh==12
replace inc_lower=6501 if q88czh==13
replace inc_lower=6001 if q88czh==14
replace inc_lower=5501 if q88czh==15
replace inc_lower=5000 if q88czh==16
replace inc_lower=0 if q88czh==17
replace inc_lower=0 if q88fra==1
replace inc_lower=1501 if q88fra==2
replace inc_lower=2001 if q88fra==3
replace inc_lower=2501 if q88fra==4
replace inc_lower=3001 if q88fra==5
replace inc_lower=4001 if q88fra==6
replace inc_lower=5001 if q88fra==7
replace inc_lower=7501 if q88fra==8
replace inc_lower=10001 if q88fra==9
replace inc_lower=15001 if q88fra==10
replace inc_lower=20001 if q88fra==11
replace inc_lower=30000 if q88fra==12
replace inc_lower=0 if q88gb==1
replace inc_lower=5000 if q88gb==2
replace inc_lower=10001 if q88gb==3
replace inc_lower=15001 if q88gb==4
replace inc_lower=20001 if q88gb==5
replace inc_lower=25001 if q88gb==6
replace inc_lower=30001 if q88gb==7
replace inc_lower=35001 if q88gb==8
replace inc_lower=40001 if q88gb==9
replace inc_lower=50001 if q88gb==10
replace inc_lower=75000 if q88gb==11
replace inc_lower=0 if q88ger==11
replace inc_lower=500 if q88ger==12
replace inc_lower=1000 if q88ger==13
replace inc_lower=1500 if q88ger==14
replace inc_lower=2000 if q88ger==15
replace inc_lower=2500 if q88ger==16
replace inc_lower=3000 if q88ger==17
replace inc_lower=3500 if q88ger==18
replace inc_lower=4000 if q88ger==19
replace inc_lower=0 if q88gha==1
replace inc_lower=100000 if q88gha==2
replace inc_lower=150000 if q88gha==3
replace inc_lower=200000 if q88gha==4
replace inc_lower=300000 if q88gha==5
replace inc_lower=400000 if q88gha==6
replace inc_lower=600000 if q88gha==7
replace inc_lower=800000 if q88gha==8
replace inc_lower=1000000 if q88gha==9
replace inc_lower=1200000 if q88gha==10
replace inc_lower=1400000 if q88gha==11
replace inc_lower=1600000 if q88gha==12
replace inc_lower=1800000 if q88gha==13
replace inc_lower=2000000 if q88gha==14
replace inc_lower=2200000 if q88gha==15
replace inc_lower=2400000 if q88gha==16
replace inc_lower=2600000 if q88gha==17
replace inc_lower=3000000 if q88gha==19
replace inc_lower=3200000 if q88gha==20
replace inc_lower=3400000 if q88gha==21
replace inc_lower=3800000 if q88gha==22
replace inc_lower=4000000 if q88gha==23
replace inc_lower=4400000 if q88gha==25
replace inc_lower=4600000 if q88gha==26
replace inc_lower=4800000 if q88gha==27
replace inc_lower=5000000 if q88gha==28
replace inc_lower=6000000 if q88gha==29
replace inc_lower=7000000 if q88gha==30
replace inc_lower=0 if q88gua==1
replace inc_lower=1601 if q88gua==2
replace inc_lower=3201 if q88gua==3
replace inc_lower=4801 if q88gua==4
replace inc_lower=6401 if q88gua==5
replace inc_lower=8001 if q88gua==6
replace inc_lower=12001 if q88gua==7
replace inc_lower=16001 if q88gua==8
replace inc_lower=20001 if q88gua==9
replace inc_lower=28001 if q88gua==11
replace inc_lower=0 if q88hon==1
replace inc_lower=3201 if q88hon==2
replace inc_lower=6401 if q88hon==3
replace inc_lower=9601 if q88hon==4
replace inc_lower=12801 if q88hon==5
replace inc_lower=16001 if q88hon==6
replace inc_lower=24001 if q88hon==7
replace inc_lower=32001 if q88hon==8
replace inc_lower=48001 if q88hon==10
replace inc_lower=56001 if q88hon==11
replace inc_lower=0 if q88ida==1
replace inc_lower=501 if q88ida==2
replace inc_lower=751 if q88ida==3
replace inc_lower=1001 if q88ida==4
replace inc_lower=1501 if q88ida==5
replace inc_lower=2001 if q88ida==6
replace inc_lower=2501 if q88ida==7
replace inc_lower=3001 if q88ida==8
replace inc_lower=4001 if q88ida==9
replace inc_lower=5001 if q88ida==10
replace inc_lower=6001 if q88ida==11
replace inc_lower=10001 if q88ida==12
replace inc_lower=15001 if q88ida==13
replace inc_lower=20001 if q88ida==14
replace inc_lower=30001 if q88ida==15
replace inc_lower=40001 if q88ida==16
replace inc_lower=0 if q88ind==1
replace inc_lower=500.001 if q88ind==2
replace inc_lower=1000.001 if q88ind==3
replace inc_lower=1500.001 if q88ind==4
replace inc_lower=2000.001 if q88ind==5
replace inc_lower=2500.001 if q88ind==6
replace inc_lower=3000.001 if q88ind==7
replace inc_lower=3500.001 if q88ind==8
replace inc_lower=4000.001 if q88ind==9
replace inc_lower=7500.001 if q88ind==11
replace inc_lower=1000.000 if q88ind==12
replace inc_lower=0 if q88ita==1
replace inc_lower=850000 if q88ita==2
replace inc_lower=1050000 if q88ita==3
replace inc_lower=1250000 if q88ita==4
replace inc_lower=1450000 if q88ita==5
replace inc_lower=1650000 if q88ita==6
replace inc_lower=1850000 if q88ita==7
replace inc_lower=2050000 if q88ita==8
replace inc_lower=2250000 if q88ita==9
replace inc_lower=2450000 if q88ita==10
replace inc_lower=2650000 if q88ita==11
replace inc_lower=3000000 if q88ita==12
replace inc_lower=3750000 if q88ita==13
replace inc_lower=4750000 if q88ita==14
replace inc_lower=7500000 if q88ita==15
replace inc_lower=0 if q88ivo==1
replace inc_lower=50001 if q88ivo==2
replace inc_lower=100001 if q88ivo==3
replace inc_lower=200001 if q88ivo==4
replace inc_lower=300001 if q88ivo==5
replace inc_lower=400001 if q88ivo==6
replace inc_lower=500000 if q88ivo==7
replace inc_lower=0 if q88jap==1
replace inc_lower=3 if q88jap==2
replace inc_lower=4 if q88jap==3
replace inc_lower=6 if q88jap==4
replace inc_lower=8 if q88jap==5
replace inc_lower=10 if q88jap==6
replace inc_lower=12 if q88jap==7
replace inc_lower=15 if q88jap==8
replace inc_lower=20 if q88jap==9
replace inc_lower=0 if q88jor==1
replace inc_lower=101 if q88jor==2
replace inc_lower=151 if q88jor==3
replace inc_lower=201 if q88jor==4
replace inc_lower=251 if q88jor==5
replace inc_lower=301 if q88jor==6
replace inc_lower=401 if q88jor==7
replace inc_lower=501 if q88jor==8
replace inc_lower=601 if q88jor==9
replace inc_lower=701 if q88jor==10
replace inc_lower=801 if q88jor==11
replace inc_lower=1001 if q88jor==12
replace inc_lower=1251 if q88jor==13
replace inc_lower=1501 if q88jor==14
replace inc_lower=1751 if q88jor==15
replace inc_lower=2501 if q88jor==17
replace inc_lower=3001 if q88jor==18
replace inc_lower=4500 if q88jor==19
replace inc_lower=0 if q88ken==1
replace inc_lower=150001 if q88ken==2
replace inc_lower=240001 if q88ken==3
replace inc_lower=480001 if q88ken==4
replace inc_lower=600001 if q88ken==5
replace inc_lower=840001 if q88ken==6
replace inc_lower=1200001 if q88ken==7
replace inc_lower=0 if q88kor==1
replace inc_lower=1000000 if q88kor==2
replace inc_lower=1500000 if q88kor==3
replace inc_lower=2000000 if q88kor==4
replace inc_lower=2500000 if q88kor==5
replace inc_lower=3000000 if q88kor==6
replace inc_lower=3500000 if q88kor==7
replace inc_lower=4000000 if q88kor==8
replace inc_lower=4500000 if q88kor==9
replace inc_lower=5000000 if q88kor==10
replace inc_lower=6000000 if q88kor==11
replace inc_lower=7000000 if q88kor==12
replace inc_lower=8000000 if q88kor==13
replace inc_lower=0 if q88leb==1
replace inc_lower=10001 if q88leb==2
replace inc_lower=15001 if q88leb==3
replace inc_lower=20001 if q88leb==4
replace inc_lower=25001 if q88leb==5
replace inc_lower=30001 if q88leb==6
replace inc_lower=35001 if q88leb==7
replace inc_lower=40001 if q88leb==8
replace inc_lower=45001 if q88leb==9
replace inc_lower=50001 if q88leb==10
replace inc_lower=60001 if q88leb==12
replace inc_lower=65001 if q88leb==13
replace inc_lower=0 if q88mal==1
replace inc_lower=50001 if q88mal==2
replace inc_lower=100001 if q88mal==3
replace inc_lower=200001 if q88mal==4
replace inc_lower=300001 if q88mal==5
replace inc_lower=400001 if q88mal==6
replace inc_lower=500000 if q88mal==7
replace inc_lower=0 if q88mex==1
replace inc_lower=1265 if q88mex==2
replace inc_lower=3795 if q88mex==3
replace inc_lower=6325 if q88mex==4
replace inc_lower=8855 if q88mex==5
replace inc_lower=12650 if q88mex==6
replace inc_lower=37950 if q88mex==7
replace inc_lower=0 if q88nig==1
replace inc_lower=50001 if q88nig==2
replace inc_lower=150001 if q88nig==3
replace inc_lower=250001 if q88nig==4
replace inc_lower=350001 if q88nig==5
replace inc_lower=450001 if q88nig==6
replace inc_lower=550001 if q88nig==7
replace inc_lower=650001 if q88nig==8
replace inc_lower=750001 if q88nig==9
replace inc_lower=850001 if q88nig==10
replace inc_lower=950001 if q88nig==11
replace inc_lower=1050001 if q88nig==12
replace inc_lower=1150001 if q88nig==13
replace inc_lower=0 if q88pak==1
replace inc_lower=4001 if q88pak==2
replace inc_lower=7001 if q88pak==3
replace inc_lower=10001 if q88pak==4
replace inc_lower=15001 if q88pak==5
replace inc_lower=20001 if q88pak==6
replace inc_lower=25001 if q88pak==7
replace inc_lower=30001 if q88pak==8
replace inc_lower=0 if q88per==1
replace inc_lower=170 if q88per==2
replace inc_lower=341 if q88per==3
replace inc_lower=511 if q88per==4
replace inc_lower=681 if q88per==5
replace inc_lower=851 if q88per==6
replace inc_lower=1021 if q88per==7
replace inc_lower=1701 if q88per==8
replace inc_lower=3401 if q88per==9
replace inc_lower=5101 if q88per==10
replace inc_lower=10200 if q88per==11
replace inc_lower=0 if q88phi==1
replace inc_lower=4001 if q88phi==2
replace inc_lower=10001 if q88phi==3
replace inc_lower=20001 if q88phi==4
replace inc_lower=30001 if q88phi==5
replace inc_lower=40001 if q88phi==6
replace inc_lower=50001 if q88phi==7
replace inc_lower=0 if q88pol==1
replace inc_lower=500 if q88pol==2
replace inc_lower=800 if q88pol==3
replace inc_lower=1000 if q88pol==4
replace inc_lower=1500 if q88pol==5
replace inc_lower=2000 if q88pol==6
replace inc_lower=2500 if q88pol==7
replace inc_lower=3000 if q88pol==8
replace inc_lower=4000 if q88pol==9
replace inc_lower=0 if q88rus==1
replace inc_lower=1501 if q88rus==2
replace inc_lower=2001 if q88rus==3
replace inc_lower=3001 if q88rus==4
replace inc_lower=4001 if q88rus==5
replace inc_lower=6001 if q88rus==6
replace inc_lower=8001 if q88rus==7
replace inc_lower=10001 if q88rus==8
replace inc_lower=15001 if q88rus==9
replace inc_lower=20000 if q88rus==10
replace inc_lower=1 if q88safr==1
replace inc_lower=100 if q88safr==2
replace inc_lower=200 if q88safr==3
replace inc_lower=300 if q88safr==4
replace inc_lower=400 if q88safr==5
replace inc_lower=500 if q88safr==6
replace inc_lower=600 if q88safr==7
replace inc_lower=700 if q88safr==8
replace inc_lower=800 if q88safr==9
replace inc_lower=900 if q88safr==10
replace inc_lower=1000 if q88safr==11
replace inc_lower=1100 if q88safr==12
replace inc_lower=1200 if q88safr==13
replace inc_lower=1400 if q88safr==14
replace inc_lower=1600 if q88safr==15
replace inc_lower=2000 if q88safr==16
replace inc_lower=2500 if q88safr==17
replace inc_lower=3000 if q88safr==18
replace inc_lower=4000 if q88safr==19
replace inc_lower=5000 if q88safr==20
replace inc_lower=6000 if q88safr==21
replace inc_lower=7000 if q88safr==22
replace inc_lower=8000 if q88safr==23
replace inc_lower=9000 if q88safr==24
replace inc_lower=10000 if q88safr==25
replace inc_lower=11000 if q88safr==26
replace inc_lower=12000 if q88safr==27
replace inc_lower=14000 if q88safr==28
replace inc_lower=16000 if q88safr==29
replace inc_lower=0 if q88sen==1
replace inc_lower=50001 if q88sen==2
replace inc_lower=100001 if q88sen==3
replace inc_lower=200001 if q88sen==4
replace inc_lower=300001 if q88sen==5
replace inc_lower=400001 if q88sen==6
replace inc_lower=500000 if q88sen==7
replace inc_lower=80 if q88slov==1
replace inc_lower=50.001 if q88slov==2
replace inc_lower=35.001 if q88slov==3
replace inc_lower=25.001 if q88slov==4
replace inc_lower=20.001 if q88slov==5
replace inc_lower=17.001 if q88slov==6
replace inc_lower=14.001 if q88slov==7
replace inc_lower=12.001 if q88slov==8
replace inc_lower=10.001 if q88slov==9
replace inc_lower=9.001 if q88slov==10
replace inc_lower=8.001 if q88slov==11
replace inc_lower=7.001 if q88slov==12
replace inc_lower=6.501 if q88slov==13
replace inc_lower=6.001 if q88slov==14
replace inc_lower=5.501 if q88slov==15
replace inc_lower=5.001 if q88slov==16
replace inc_lower=0 if q88slov==17
replace inc_lower=0 if q88tan==1
replace inc_lower=600001 if q88tan==2
replace inc_lower=1200001 if q88tan==3
replace inc_lower=1800001 if q88tan==4
replace inc_lower=2400001 if q88tan==5
replace inc_lower=3000001 if q88tan==6
replace inc_lower=4200001 if q88tan==7
replace inc_lower=4800001 if q88tan==8
replace inc_lower=5400000 if q88tan==9
replace inc_lower=0 if q88tur==1
replace inc_lower=150000001 if q88tur==2
replace inc_lower=300000001 if q88tur==3
replace inc_lower=500000001 if q88tur==4
replace inc_lower=700000001 if q88tur==5
replace inc_lower=900000001 if q88tur==6
replace inc_lower=1000000001 if q88tur==7
replace inc_lower=1300000001 if q88tur==8
replace inc_lower=1600000001 if q88tur==9
replace inc_lower=1800000001 if q88tur==10
replace inc_lower=2000000001 if q88tur==11
replace inc_lower=2500000001 if q88tur==12
replace inc_lower=3000000000 if q88tur==13
replace inc_lower=0 if q88uga==1
replace inc_lower=50100 if q88uga==2
replace inc_lower=101000 if q88uga==3
replace inc_lower=151000 if q88uga==4
replace inc_lower=201000 if q88uga==5
replace inc_lower=251000 if q88uga==6
replace inc_lower=301000 if q88uga==7
replace inc_lower=401000 if q88uga==8
replace inc_lower=500000 if q88uga==9
replace inc_lower=0 if q88ukr==1
replace inc_lower=100 if q88ukr==2
replace inc_lower=201 if q88ukr==3
replace inc_lower=301 if q88ukr==4
replace inc_lower=501 if q88ukr==5
replace inc_lower=701 if q88ukr==6
replace inc_lower=1001 if q88ukr==7
replace inc_lower=1500 if q88ukr==8
replace inc_lower=0 if q88usa==1
replace inc_lower=10000 if q88usa==2
replace inc_lower=20000 if q88usa==3
replace inc_lower=30000 if q88usa==4
replace inc_lower=40000 if q88usa==5
replace inc_lower=50000 if q88usa==6
replace inc_lower=75000 if q88usa==7
replace inc_lower=100000 if q88usa==8
replace inc_lower=0 if q88uzb==1
replace inc_lower=10001 if q88uzb==2
replace inc_lower=15001 if q88uzb==3
replace inc_lower=20001 if q88uzb==4
replace inc_lower=30001 if q88uzb==5
replace inc_lower=40001 if q88uzb==6
replace inc_lower=50001 if q88uzb==7
replace inc_lower=60001 if q88uzb==8
replace inc_lower=70001 if q88uzb==9
replace inc_lower=80001 if q88uzb==10
replace inc_lower=0 if q88ven==1
replace inc_lower=600001 if q88ven==2
replace inc_lower=700001 if q88ven==3
replace inc_lower=800001 if q88ven==4
replace inc_lower=900001 if q88ven==5
replace inc_lower=1000001 if q88ven==6
replace inc_lower=1600001 if q88ven==7
replace inc_lower=2000000 if q88ven==8
replace inc_lower=0 if q88viet==0
replace inc_lower=20001 if q88viet==2
replace inc_lower=50001 if q88viet==3
replace inc_lower=100001 if q88viet==4
replace inc_lower=150001 if q88viet==5
replace inc_lower=200001 if q88viet==6
replace inc_lower=300001 if q88viet==7
replace inc_lower=400001 if q88viet==8
replace inc_lower=500001 if q88viet==9
replace inc_lower=600001 if q88viet==10
replace inc_lower=700001 if q88viet==11
replace inc_lower=800001 if q88viet==12
replace inc_lower=900001 if q88viet==13
replace inc_lower=1000001 if q88viet==14
replace inc_lower=1500001 if q88viet==15
replace inc_lower=2000001 if q88viet==16
replace inc_lower=2500001 if q88viet==17
replace inc_lower=3000001 if q88viet==18
replace inc_lower=3500001 if q88viet==19
replace inc_lower=4000001 if q88viet==20
replace inc_lower=4500001 if q88viet==21
replace inc_lower=5000001 if q88viet==22
replace inc_lower=6000001 if q88viet==23
replace inc_lower=7000001 if q88viet==24
replace inc_lower=8000001 if q88viet==25
replace inc_lower=9000001 if q88viet==26
replace inc_lower=10000001 if q88viet==27
replace inc_lower=14000001 if q88viet==31
replace inc_lower=15000000 if q88viet==32
replace inc_upper=499 if q88ang==1
replace inc_upper=999 if q88ang==2
replace inc_upper=1499 if q88ang==3
replace inc_upper=1999 if q88ang==4
replace inc_upper=2499 if q88ang==5
replace inc_upper=2999 if q88ang==6
replace inc_upper=3499 if q88ang==7
replace inc_upper=3999 if q88ang==8
replace inc_upper=4499 if q88ang==9
replace inc_upper=4999 if q88ang==10
replace inc_upper=5499 if q88ang==11
replace inc_upper=5999 if q88ang==12
replace inc_upper=6499 if q88ang==13
replace inc_upper=6999 if q88ang==14
replace inc_upper=7499 if q88ang==15
replace inc_upper=7999 if q88ang==16
replace inc_upper=8499 if q88ang==17
replace inc_upper=8999 if q88ang==18
replace inc_upper=9499 if q88ang==19
replace inc_upper=9999 if q88ang==20
replace inc_upper=10999 if q88ang==21
replace inc_upper=11499 if q88ang==22
replace inc_upper=11999 if q88ang==23
replace inc_upper=12499 if q88ang==24
replace inc_upper=13499 if q88ang==25
replace inc_upper=14499 if q88ang==26
replace inc_upper=14999 if q88ang==27
replace inc_upper=15999 if q88ang==28
replace inc_upper=-9 if q88ang==29
replace inc_upper=-9 if q88arg==1
replace inc_upper=10000 if q88arg==4
replace inc_upper=8000 if q88arg==5
replace inc_upper=5000 if q88arg==6
replace inc_upper=3000 if q88arg==7
replace inc_upper=2000 if q88arg==8
replace inc_upper=1600 if q88arg==9
replace inc_upper=1300 if q88arg==10
replace inc_upper=1000 if q88arg==11
replace inc_upper=850 if q88arg==12
replace inc_upper=700 if q88arg==13
replace inc_upper=550 if q88arg==14
replace inc_upper=450 if q88arg==15
replace inc_upper=350 if q88arg==16
replace inc_upper=200 if q88arg==17
replace inc_upper=9999 if q88ban==1
replace inc_upper=14999 if q88ban==2
replace inc_upper=19999 if q88ban==3
replace inc_upper=49999 if q88ban==4
replace inc_upper=99999 if q88ban==5
replace inc_upper=-9 if q88ban==6
replace inc_upper=200 if q88bol==1
replace inc_upper=400 if q88bol==2
replace inc_upper=600 if q88bol==3
replace inc_upper=800 if q88bol==4
replace inc_upper=1000 if q88bol==5
replace inc_upper=1500 if q88bol==6
replace inc_upper=2000 if q88bol==7
replace inc_upper=5000 if q88bol==8
replace inc_upper=7500 if q88bol==9
replace inc_upper=10000 if q88bol==10
replace inc_upper=15000 if q88bol==11
replace inc_upper=20000 if q88bol==12
replace inc_upper=-9 if q88bol==13
replace inc_upper=200 if q88braz==1
replace inc_upper=400 if q88braz==2
replace inc_upper=600 if q88braz==3
replace inc_upper=1000 if q88braz==4
replace inc_upper=1400 if q88braz==5
replace inc_upper=2000 if q88braz==6
replace inc_upper=3000 if q88braz==7
replace inc_upper=4000 if q88braz==8
replace inc_upper=6000 if q88braz==9
replace inc_upper=10000 if q88braz==10
replace inc_upper=15000 if q88braz==11
replace inc_upper=-9 if q88braz==12
replace inc_upper=99 if q88bul==1
replace inc_upper=199 if q88bul==2
replace inc_upper=299 if q88bul==3
replace inc_upper=399 if q88bul==4
replace inc_upper=499 if q88bul==5
replace inc_upper=599 if q88bul==6
replace inc_upper=699 if q88bul==7
replace inc_upper=799 if q88bul==8
replace inc_upper=899 if q88bul==9
replace inc_upper=999 if q88bul==10
replace inc_upper=-9 if q88bul==11
replace inc_upper=20000 if q88can==1
replace inc_upper=30000 if q88can==2
replace inc_upper=40000 if q88can==3
replace inc_upper=60000 if q88can==4
replace inc_upper=80000 if q88can==5
replace inc_upper=100000 if q88can==6
replace inc_upper=-9 if q88can==7
replace inc_upper=500 if q88chi==1
replace inc_upper=999 if q88chi==2
replace inc_upper=1499 if q88chi==3
replace inc_upper=1999 if q88chi==4
replace inc_upper=2499 if q88chi==5
replace inc_upper=2999 if q88chi==6
replace inc_upper=3999 if q88chi==7
replace inc_upper=4999 if q88chi==8
replace inc_upper=5999 if q88chi==9
replace inc_upper=6999 if q88chi==10
replace inc_upper=7999 if q88chi==11
replace inc_upper=-9 if q88chi==12
replace inc_upper=-9 if q88czh==1
replace inc_upper=80000 if q88czh==2
replace inc_upper=50000 if q88czh==3
replace inc_upper=35000 if q88czh==4
replace inc_upper=25000 if q88czh==5
replace inc_upper=20000 if q88czh==6
replace inc_upper=17000 if q88czh==7
replace inc_upper=14000 if q88czh==8
replace inc_upper=12000 if q88czh==9
replace inc_upper=10000 if q88czh==10
replace inc_upper=9000 if q88czh==11
replace inc_upper=8000 if q88czh==12
replace inc_upper=7000 if q88czh==13
replace inc_upper=6500 if q88czh==14
replace inc_upper=6000 if q88czh==15
replace inc_upper=5500 if q88czh==16
replace inc_upper=5000 if q88czh==17
replace inc_upper=1500 if q88fra==1
replace inc_upper=2000 if q88fra==2
replace inc_upper=2500 if q88fra==3
replace inc_upper=3000 if q88fra==4
replace inc_upper=4000 if q88fra==5
replace inc_upper=5000 if q88fra==6
replace inc_upper=7500 if q88fra==7
replace inc_upper=10000 if q88fra==8
replace inc_upper=15000 if q88fra==9
replace inc_upper=20000 if q88fra==10
replace inc_upper=30000 if q88fra==11
replace inc_upper=-9 if q88fra==12
replace inc_upper=5000 if q88gb==1
replace inc_upper=10000 if q88gb==2
replace inc_upper=15000 if q88gb==3
replace inc_upper=20000 if q88gb==4
replace inc_upper=25000 if q88gb==5
replace inc_upper=30000 if q88gb==6
replace inc_upper=35000 if q88gb==7
replace inc_upper=40000 if q88gb==8
replace inc_upper=50000 if q88gb==9
replace inc_upper=75000 if q88gb==10
replace inc_upper=-9 if q88gb==11
replace inc_upper=500 if q88ger==11
replace inc_upper=1000 if q88ger==12
replace inc_upper=1500 if q88ger==13
replace inc_upper=2000 if q88ger==14
replace inc_upper=3000 if q88ger==15
replace inc_upper=3000 if q88ger==16
replace inc_upper=3500 if q88ger==17
replace inc_upper=4000 if q88ger==18
replace inc_upper=-9 if q88ger==19
replace inc_upper=99000 if q88gha==1
replace inc_upper=149000 if q88gha==2
replace inc_upper=199000 if q88gha==3
replace inc_upper=299000 if q88gha==4
replace inc_upper=399000 if q88gha==5
replace inc_upper=599000 if q88gha==6
replace inc_upper=799000 if q88gha==7
replace inc_upper=999000 if q88gha==8
replace inc_upper=1199000 if q88gha==9
replace inc_upper=1399000 if q88gha==10
replace inc_upper=1599000 if q88gha==11
replace inc_upper=1799000 if q88gha==12
replace inc_upper=1999000 if q88gha==13
replace inc_upper=2199000 if q88gha==14
replace inc_upper=2399000 if q88gha==15
replace inc_upper=2599000 if q88gha==16
replace inc_upper=2799000 if q88gha==17
replace inc_upper=3199000 if q88gha==19
replace inc_upper=3399000 if q88gha==20
replace inc_upper=3799000 if q88gha==21
replace inc_upper=3999000 if q88gha==22
replace inc_upper=4199000 if q88gha==23
replace inc_upper=4599000 if q88gha==25
replace inc_upper=47990000 if q88gha==26
replace inc_upper=4999000 if q88gha==27
replace inc_upper=5999000 if q88gha==28
replace inc_upper=6999000 if q88gha==29
replace inc_upper=-9 if q88gha==30
replace inc_upper=1600 if q88gua==1
replace inc_upper=3200 if q88gua==2
replace inc_upper=4800 if q88gua==3
replace inc_upper=6400 if q88gua==4
replace inc_upper=8000 if q88gua==5
replace inc_upper=12000 if q88gua==6
replace inc_upper=16000 if q88gua==7
replace inc_upper=20000 if q88gua==8
replace inc_upper=24000 if q88gua==9
replace inc_upper=-9 if q88gua==11
replace inc_upper=3200 if q88hon==1
replace inc_upper=6400 if q88hon==2
replace inc_upper=9600 if q88hon==3
replace inc_upper=12800 if q88hon==4
replace inc_upper=16000 if q88hon==5
replace inc_upper=24000 if q88hon==6
replace inc_upper=32000 if q88hon==7
replace inc_upper=40000 if q88hon==8
replace inc_upper=56000 if q88hon==10
replace inc_upper=-9 if q88hon==11
replace inc_upper=500 if q88ida==1
replace inc_upper=750 if q88ida==2
replace inc_upper=1000 if q88ida==3
replace inc_upper=1500 if q88ida==4
replace inc_upper=2000 if q88ida==5
replace inc_upper=2500 if q88ida==6
replace inc_upper=3000 if q88ida==7
replace inc_upper=4000 if q88ida==8
replace inc_upper=5000 if q88ida==9
replace inc_upper=6000 if q88ida==10
replace inc_upper=10000 if q88ida==11
replace inc_upper=15000 if q88ida==12
replace inc_upper=20000 if q88ida==13
replace inc_upper=30000 if q88ida==14
replace inc_upper=40000 if q88ida==15
replace inc_upper=-9 if q88ida==16
replace inc_upper=500 if q88ind==1
replace inc_upper=1000 if q88ind==2
replace inc_upper=1500 if q88ind==3
replace inc_upper=2000 if q88ind==4
replace inc_upper=2500 if q88ind==5
replace inc_upper=3000 if q88ind==6
replace inc_upper=3500 if q88ind==7
replace inc_upper=4000 if q88ind==8
replace inc_upper=5000 if q88ind==9
replace inc_upper=10000 if q88ind==11
replace inc_upper=-9 if q88ind==12
replace inc_upper=850000 if q88ita==1
replace inc_upper=1050000 if q88ita==2
replace inc_upper=1250000 if q88ita==3
replace inc_upper=1450000 if q88ita==4
replace inc_upper=1650000 if q88ita==5
replace inc_upper=1850000 if q88ita==6
replace inc_upper=2050000 if q88ita==7
replace inc_upper=2250000 if q88ita==8
replace inc_upper=2450000 if q88ita==9
replace inc_upper=2650000 if q88ita==10
replace inc_upper=3000000 if q88ita==11
replace inc_upper=3750000 if q88ita==12
replace inc_upper=4750000 if q88ita==13
replace inc_upper=7500000 if q88ita==14
replace inc_upper=-9 if q88ita==15
replace inc_upper=50000 if q88ivo==1
replace inc_upper=100000 if q88ivo==2
replace inc_upper=200000 if q88ivo==3
replace inc_upper=300000 if q88ivo==4
replace inc_upper=400000 if q88ivo==5
replace inc_upper=500000 if q88ivo==6
replace inc_upper=-9 if q88ivo==7
replace inc_upper=2 if q88jap==1
replace inc_upper=4 if q88jap==2
replace inc_upper=5 if q88jap==3
replace inc_upper=7 if q88jap==4
replace inc_upper=9 if q88jap==5
replace inc_upper=11 if q88jap==6
replace inc_upper=14 if q88jap==7
replace inc_upper=19 if q88jap==8
replace inc_upper=-9 if q88jap==9
replace inc_upper=100 if q88jor==1
replace inc_upper=150 if q88jor==2
replace inc_upper=200 if q88jor==3
replace inc_upper=250 if q88jor==4
replace inc_upper=300 if q88jor==5
replace inc_upper=400 if q88jor==6
replace inc_upper=500 if q88jor==7
replace inc_upper=600 if q88jor==8
replace inc_upper=700 if q88jor==9
replace inc_upper=800 if q88jor==10
replace inc_upper=1000 if q88jor==11
replace inc_upper=1250 if q88jor==12
replace inc_upper=1500 if q88jor==13
replace inc_upper=1750 if q88jor==14
replace inc_upper=2000 if q88jor==15
replace inc_upper=3000 if q88jor==17
replace inc_upper=4500 if q88jor==18
replace inc_upper=-9 if q88jor==19
replace inc_upper=150000 if q88ken==1
replace inc_upper=240000 if q88ken==2
replace inc_upper=480000 if q88ken==3
replace inc_upper=600000 if q88ken==4
replace inc_upper=840000 if q88ken==5
replace inc_upper=1200000 if q88ken==6
replace inc_upper=1800000 if q88ken==7
replace inc_upper=990000 if q88kor==1
replace inc_upper=1490000 if q88kor==2
replace inc_upper=1990000 if q88kor==3
replace inc_upper=2490000 if q88kor==4
replace inc_upper=2990000 if q88kor==5
replace inc_upper=3490000 if q88kor==6
replace inc_upper=3990000 if q88kor==7
replace inc_upper=4490000 if q88kor==8
replace inc_upper=4990000 if q88kor==9
replace inc_upper=5490000 if q88kor==10
replace inc_upper=6990000 if q88kor==11
replace inc_upper=7990000 if q88kor==12
replace inc_upper=-9 if q88kor==13
replace inc_upper=10000 if q88leb==1
replace inc_upper=15000 if q88leb==2
replace inc_upper=20000 if q88leb==3
replace inc_upper=25000 if q88leb==4
replace inc_upper=30000 if q88leb==5
replace inc_upper=35000 if q88leb==6
replace inc_upper=40000 if q88leb==7
replace inc_upper=45000 if q88leb==8
replace inc_upper=50000 if q88leb==9
replace inc_upper=55000 if q88leb==10
replace inc_upper=65000 if q88leb==12
replace inc_upper=70000 if q88leb==13
replace inc_upper=50000 if q88mal==1
replace inc_upper=100000 if q88mal==2
replace inc_upper=200000 if q88mal==3
replace inc_upper=300000 if q88mal==4
replace inc_upper=400000 if q88mal==5
replace inc_upper=500000 if q88mal==6
replace inc_upper=-9 if q88mal==7
replace inc_upper=1265 if q88mex==1
replace inc_upper=3795 if q88mex==2
replace inc_upper=6325 if q88mex==3
replace inc_upper=8855 if q88mex==4
replace inc_upper=12650 if q88mex==5
replace inc_upper=37950 if q88mex==6
replace inc_upper=-9 if q88mex==7
replace inc_upper=50000 if q88nig==1
replace inc_upper=150000 if q88nig==2
replace inc_upper=350000 if q88nig==3
replace inc_upper=350000 if q88nig==4
replace inc_upper=450000 if q88nig==5
replace inc_upper=550000 if q88nig==6
replace inc_upper=650000 if q88nig==7
replace inc_upper=750000 if q88nig==8
replace inc_upper=850000 if q88nig==9
replace inc_upper=950000 if q88nig==10
replace inc_upper=1050000 if q88nig==11
replace inc_upper=1150000 if q88nig==12
replace inc_upper=-9 if q88nig==13
replace inc_upper=4000 if q88pak==1
replace inc_upper=7000 if q88pak==2
replace inc_upper=10000 if q88pak==3
replace inc_upper=15000 if q88pak==4
replace inc_upper=20000 if q88pak==5
replace inc_upper=25000 if q88pak==6
replace inc_upper=30000 if q88pak==7
replace inc_upper=-9 if q88pak==8
replace inc_upper=170 if q88per==1
replace inc_upper=340 if q88per==2
replace inc_upper=510 if q88per==3
replace inc_upper=680 if q88per==4
replace inc_upper=850 if q88per==5
replace inc_upper=1020 if q88per==6
replace inc_upper=1700 if q88per==7
replace inc_upper=3400 if q88per==8
replace inc_upper=5100 if q88per==9
replace inc_upper=10200 if q88per==10
replace inc_upper=-9 if q88per==11
replace inc_upper=4000 if q88phi==1
replace inc_upper=10000 if q88phi==2
replace inc_upper=20000 if q88phi==3
replace inc_upper=30000 if q88phi==4
replace inc_upper=40000 if q88phi==5
replace inc_upper=50000 if q88phi==6
replace inc_upper=-9 if q88phi==7
replace inc_upper=500 if q88pol==1
replace inc_upper=799 if q88pol==2
replace inc_upper=999 if q88pol==3
replace inc_upper=1499 if q88pol==4
replace inc_upper=1999 if q88pol==5
replace inc_upper=2499 if q88pol==6
replace inc_upper=2999 if q88pol==7
replace inc_upper=3999 if q88pol==8
replace inc_upper=-9 if q88pol==9
replace inc_upper=1500 if q88rus==1
replace inc_upper=2000 if q88rus==2
replace inc_upper=3000 if q88rus==3
replace inc_upper=4000 if q88rus==4
replace inc_upper=6000 if q88rus==5
replace inc_upper=8000 if q88rus==6
replace inc_upper=10000 if q88rus==7
replace inc_upper=15000 if q88rus==8
replace inc_upper=20000 if q88rus==9
replace inc_upper=-9 if q88rus==10
replace inc_upper=99 if q88safr==1
replace inc_upper=199 if q88safr==2
replace inc_upper=299 if q88safr==3
replace inc_upper=399 if q88safr==4
replace inc_upper=499 if q88safr==5
replace inc_upper=599 if q88safr==6
replace inc_upper=699 if q88safr==7
replace inc_upper=799 if q88safr==8
replace inc_upper=899 if q88safr==9
replace inc_upper=999 if q88safr==10
replace inc_upper=1099 if q88safr==11
replace inc_upper=1199 if q88safr==12
replace inc_upper=1399 if q88safr==13
replace inc_upper=1599 if q88safr==14
replace inc_upper=1999 if q88safr==15
replace inc_upper=2499 if q88safr==16
replace inc_upper=2999 if q88safr==17
replace inc_upper=3999 if q88safr==18
replace inc_upper=4999 if q88safr==19
replace inc_upper=5999 if q88safr==20
replace inc_upper=6999 if q88safr==21
replace inc_upper=7999 if q88safr==22
replace inc_upper=8999 if q88safr==23
replace inc_upper=9999 if q88safr==24
replace inc_upper=10999 if q88safr==25
replace inc_upper=11999 if q88safr==26
replace inc_upper=13999 if q88safr==27
replace inc_upper=15999 if q88safr==28
replace inc_upper=-9 if q88safr==29
replace inc_upper=50000 if q88sen==1
replace inc_upper=100000 if q88sen==2
replace inc_upper=200000 if q88sen==3
replace inc_upper=300000 if q88sen==4
replace inc_upper=400000 if q88sen==5
replace inc_upper=500000 if q88sen==6
replace inc_upper=-9 if q88sen==7
replace inc_upper=-9 if q88slov==1
replace inc_upper=80 if q88slov==2
replace inc_upper=50 if q88slov==3
replace inc_upper=35 if q88slov==4
replace inc_upper=25 if q88slov==5
replace inc_upper=20 if q88slov==6
replace inc_upper=17 if q88slov==7
replace inc_upper=14 if q88slov==8
replace inc_upper=12 if q88slov==9
replace inc_upper=10 if q88slov==10
replace inc_upper=9 if q88slov==11
replace inc_upper=8 if q88slov==12
replace inc_upper=7 if q88slov==13
replace inc_upper=6.5 if q88slov==14
replace inc_upper=6 if q88slov==15
replace inc_upper=5.5 if q88slov==16
replace inc_upper=4.999 if q88slov==17
replace inc_upper=600000 if q88tan==1
replace inc_upper=1200000 if q88tan==2
replace inc_upper=1800000 if q88tan==3
replace inc_upper=2400000 if q88tan==4
replace inc_upper=3000000 if q88tan==5
replace inc_upper=4200000 if q88tan==6
replace inc_upper=4800000 if q88tan==7
replace inc_upper=5400000 if q88tan==8
replace inc_upper=-9 if q88tan==9
replace inc_upper=150000000 if q88tur==1
replace inc_upper=300000000 if q88tur==2
replace inc_upper=500000000 if q88tur==3
replace inc_upper=700000000 if q88tur==4
replace inc_upper=900000000 if q88tur==5
replace inc_upper=1000000000 if q88tur==6
replace inc_upper=1300000000 if q88tur==7
replace inc_upper=1600000000 if q88tur==8
replace inc_upper=1800000000 if q88tur==9
replace inc_upper=2000000000 if q88tur==10
replace inc_upper=2500000000 if q88tur==11
replace inc_upper=3000000000 if q88tur==12
replace inc_upper=-9 if q88tur==13
replace inc_upper=50000 if q88uga==1
replace inc_upper=100000 if q88uga==2
replace inc_upper=150000 if q88uga==3
replace inc_upper=200000 if q88uga==4
replace inc_upper=250000 if q88uga==5
replace inc_upper=300000 if q88uga==6
replace inc_upper=400000 if q88uga==7
replace inc_upper=500000 if q88uga==8
replace inc_upper=-9 if q88uga==9
replace inc_upper=100 if q88ukr==1
replace inc_upper=200 if q88ukr==2
replace inc_upper=300 if q88ukr==3
replace inc_upper=500 if q88ukr==4
replace inc_upper=700 if q88ukr==5
replace inc_upper=1000 if q88ukr==6
replace inc_upper=1500 if q88ukr==7
replace inc_upper=-9 if q88ukr==8
replace inc_upper=9999 if q88usa==1
replace inc_upper=20000 if q88usa==2
replace inc_upper=30000 if q88usa==3
replace inc_upper=40000 if q88usa==4
replace inc_upper=50000 if q88usa==5
replace inc_upper=75000 if q88usa==6
replace inc_upper=100000 if q88usa==7
replace inc_upper=-9 if q88usa==8
replace inc_upper=1500 if q88uzb==1
replace inc_upper=15000 if q88uzb==2
replace inc_upper=20000 if q88uzb==3
replace inc_upper=30000 if q88uzb==4
replace inc_upper=40000 if q88uzb==5
replace inc_upper=50000 if q88uzb==6
replace inc_upper=60000 if q88uzb==7
replace inc_upper=70000 if q88uzb==8
replace inc_upper=80000 if q88uzb==9
replace inc_upper=-9 if q88uzb==10
replace inc_upper=600000 if q88ven==1
replace inc_upper=700000 if q88ven==2
replace inc_upper=800000 if q88ven==3
replace inc_upper=900000 if q88ven==4
replace inc_upper=1000000 if q88ven==5
replace inc_upper=1600000 if q88ven==6
replace inc_upper=1800000 if q88ven==7
replace inc_upper=-9 if q88ven==8
replace inc_upper=0 if q88viet==0
replace inc_upper=50000 if q88viet==2
replace inc_upper=100000 if q88viet==3
replace inc_upper=150000 if q88viet==4
replace inc_upper=200000 if q88viet==5
replace inc_upper=300000 if q88viet==6
replace inc_upper=400000 if q88viet==7
replace inc_upper=500000 if q88viet==8
replace inc_upper=600000 if q88viet==9
replace inc_upper=700000 if q88viet==10
replace inc_upper=800000 if q88viet==11
replace inc_upper=900000 if q88viet==12
replace inc_upper=1000000 if q88viet==13
replace inc_upper=1500000 if q88viet==14
replace inc_upper=2000000 if q88viet==15
replace inc_upper=2500000 if q88viet==16
replace inc_upper=3000000 if q88viet==17
replace inc_upper=3500000 if q88viet==18
replace inc_upper=4000000 if q88viet==19
replace inc_upper=4500000 if q88viet==20
replace inc_upper=5000000 if q88viet==21
replace inc_upper=6000000 if q88viet==22
replace inc_upper=7000000 if q88viet==23
replace inc_upper=8000000 if q88viet==24
replace inc_upper=9000000 if q88viet==25
replace inc_upper=10000000 if q88viet==26
replace inc_upper=11000000 if q88viet==27
replace inc_upper=15000000 if q88viet==31
replace inc_upper=-9 if q88viet==32

gen str40 educ=""
la var educ "Education: Local country codes"
foreach v of varlist q84* {
	local vl: value label `v'
	levelsof(`v'), local(values)
	foreach l of local values {
		local lb: label `vl' `l'
		replace educ="`v': `lb'" if `v'==`l'
		if strpos("`lb'", "refused")>0 | strpos("`lb'", "don't know")>0 {
			replace educ="" if `v'==`l'
		}
	}
}


** Interval regression to infer average income in each bin
gen top_coded=0 if inc_lower~=.
gen bottom_coded=0 if inc_lower~=.
gen lninc=.
levelsof cty, local(ctys)
foreach c of local ctys {
	summ inc_lower if cty=="`c'"
	if r(N)>0 {
		* Deal with zero incomes: Combine them with the preceding grouping
		summ inc_lower if cty=="`c'" & inc_lower~=-9
		local ll=r(min)
		summ inc_upper if cty=="`c'" & inc_upper~=-9
		local lu=r(min)
		if `ll'==0 & `lu'==0 {
			summ inc_lower if cty=="`c'" & inc_lower~=-9 & inc_lower~=0
			local l2=r(min)
			summ inc_upper if cty=="`c'" & inc_upper~=-9 & inc_upper~=0
			local u2=r(min)
			replace inc_lower=`l2' if cty=="`c'" & inc_lower==0 & inc_upper==0
			replace inc_upper=`u2' if cty=="`c'" & inc_lower==`l2' & inc_upper==0
			replace inc_lower=0 if cty=="`c'" & inc_lower==`l2' & inc_upper==`u2'
		}
		summ inc_lower if cty=="`c'" & inc_lower~=-9
		replace bottom_coded=1 if cty=="`c'" & inc_lower==r(min)
		* Do interval regression
		gen u=ln(inc_upper) if cty=="`c'"
		replace u=. if inc_upper==-9 & cty=="`c'"
		gen l=ln(inc_lower) if cty=="`c'"
		replace l=. if inc_lower==0 & cty=="`c'"
		intreg l u if cty=="`c'" [pw=wt]
		egen grp=group(inc_lower inc_upper) if cty=="`c'"
		levelsof grp, local(groups)
		foreach g of local groups {
			qui summ l if cty=="`c'" & grp==`g'
			local lower=r(mean)
			qui summ u if cty=="`c'" & grp==`g'
			local upper=r(mean)
			predict hat, e(`lower',`upper')
			replace lninc=hat if cty=="`c'" & grp==`g'
			drop hat
		}
		drop l u grp
	}
}
gen inc=exp(lninc)
la var lninc "Ln(Income) - own-country units"
for var q88*: gen iX=X \ table X, c(m iX m inc) \ drop iX


***

compress
saveold "Processed files\Pew", replace


